/* Katy Perdue
   Created on or before May 24, 2003 */

:-ensure_loaded(equals).
:-ensure_loaded(scales).

reverse(X, Y):-reverse(X, [], Y).

reverse([H|T], Acc, Y):- reverse(T, [H|Acc], Y).
reverse([], Y, Y).

maj7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev), 
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes), 
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    write('Root: '), write(Root), nl, 
    write('Third: '), write(Third), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Seventh: '), write(Seventh), nl.

majCheck([J, A, M, _|_]):- J==106, A==97, (M==77 ; M== 109).
extract7([ Root, _, Third, _, Fifth ,_, Seventh], Root, Third, Fifth, Seventh).

min7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev),
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Third, FlatThird),
    flat(Seventh, FlatSeventh),
    write('Root: '), write(Root), nl,
    write('Third: '), write(FlatThird), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Seventh: '), write(FlatSeventh), nl.


minMaj7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev),
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Third, FlatThird),
    write('Root: '), write(Root), nl,
    write('Third: '), write(FlatThird), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Seventh: '), write(Seventh), nl.

    

min7flat5(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev),
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Third, FlatThird),
    flat(Fifth, FlatFifth),
    flat(Seventh, FlatSeventh),
    write('Root: '), write(Root), nl,
    write('Third: '), write(FlatThird), nl,
    write('Fifth: '), write(FlatFifth), nl,
    write('Seventh: '), write(FlatSeventh), nl.


dom7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev),
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Seventh, FlatSeventh),
    write('Root: '), write(Root), nl,
    write('Third: '), write(Third), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Seventh: '), write(FlatSeventh), nl.

dim7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    name(ScaleInt, X),
    reverse(X, Xrev),
    majCheck(Xrev),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Seventh, FlatSeventh),
    flat(FlatSeventh, DoubFlatSeventh),
    flat(Third, FlatThird),
    flat(Fifth, FlatFifth),
    write('Root: '), write(Root), nl,
    write('Third: '), write(FlatThird), nl,
    write('Fifth: '), write(FlatFifth), nl,
    write('Seventh: '), write(DoubFlatSeventh), nl.


sus(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    scale(ScaleInt, ScaleNotes),
    extractSus(ScaleNotes, Root, Fourth, Fifth),
    write('Root: '), write(Root), nl, 
    write('Fourth: '), write(Fourth), nl,
    write('Fifth: '), write(Fifth), nl.
    

extractSus([Root, _, _, Fourth, Fifth, _, _], Root, Fourth, Fifth).

six(ScaleIn):-
 equals(ScaleIn, ScaleInt),
    scale(ScaleInt, ScaleNotes),   
    extractSus(ScaleNotes, Root, Third, Fifth, Sixth),
    write('Root: '), write(Root), nl,
    write('Third: '), write(Third), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Sixth: '), write(Sixth), nl.

extractSus([Root, _,Third ,_ , Fifth, Sixth, _], Root, Third, Fifth, Sixth).

sus7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    scale(ScaleInt, ScaleNotes),
    extractSus7(ScaleNotes, Root, Fourth, Fifth, Seventh),
    flat(Seventh, FlatSeventh),
    write('Root: '), write(Root), nl,
    write('Fourth: '), write(Fourth), nl,
    write('Fifth: '), write(Fifth), nl,
    write('Seventh: '), write(FlatSeventh), nl.

extractSus7([Root, _, _, Fourth, Fifth, _, Seventh], Root, Fourth, Fifth, Seventh).



aug7(ScaleIn):-
    equals(ScaleIn, ScaleInt),
    scale(ScaleInt, ScaleNotes),
    extract7(ScaleNotes, Root, Third, Fifth, Seventh),
    flat(Seventh, FlatSeventh),
    sharp(Fifth, SharpFifth),
    write('Root: '), write(Root), nl,
    write('Third: '), write(Third), nl,
    write('Fifth: '), write(SharpFifth), nl,
    write('Seventh: '), write(FlatSeventh), nl.

/* For use when enharmonic spelling is relevent

flat(Note, FlatNote):-
    equals(Note, NoteInt),
    hStepDown(NoteInt, FlatNote).

sharp(Note, SharpNote):-
    equals(Note, NoteInt),
    hStepDown(SharpNote, NoteInt).*/


flat(Note, FlatNote):-
    hStepDown2(Note, FlatNote).

sharp(Note, SharpNote):-
    hStepDown2(SharpNote, Note).

/* For use when enharmonic spellings are all that's needed.
   This set maps all changes to their most common spelling. */

hStepDown('A', 'A_flat').
hStepDown('B_flat', 'A').
hStepDown('B', 'B_flat'). 
hStepDown('C', 'B').
hStepDown('C_sharp', 'C').
hStepDown('D', 'C_sharp').
hStepDown('E_flat', 'D').
hStepDown('E', 'E_flat').
hStepDown('F', 'E').
hStepDown('F_sharp', 'F').
hStepDown('G', 'F_sharp').
hStepDown('G_sharp', 'G').


/* For use when trying to figure out scale degrees.  This 
   set keeps the original note class.  */

hStepDown2('A', 'A_flat').
hStepDown2('B', 'B_flat').
hStepDown2('C', 'C_flat').
hStepDown2('D', 'D_flat').
hStepDown2('E', 'E_flat').
hStepDown2('F', 'F_flat').
hStepDown2('G', 'G_flat').
hStepDown2('A_flat', 'A_doubFlat').
hStepDown2('B_flat', 'B_doubFlat').
hStepDown2('C_flat', 'C_doubFlat').
hStepDown2('D_flat', 'D_doubFlat').
hStepDown2('E_flat', 'E_doubFlat').
hStepDown2('F_flat', 'F_doubFlat').
hStepDown2('G_flat', 'G_doubFlat').
hStepDown2('A_sharp', 'A').
hStepDown2('B_sharp', 'B').
hStepDown2('C_sharp', 'C').
hStepDown2('D_sharp', 'D').
hStepDown2('E_sharp', 'E').
hStepDown2('F_sharp', 'F').
hStepDown2('G_sharp', 'G').




