/* Katy Perdue
   Created on or before May 28, 2003 */


/* This version of class is most useful in the parse2 functor.  It takes
   a note that has already been changed to it's appriopriate number, and 
   decides which class it belongs to.  This version understands upper and 
   lower case class names. */

class([Note|_], ClassName):-
    ';'(Note==65, Note==97),
    ClassName='A', !.

class([Note|_], ClassName):-
    ';'(Note==66, Note==98),
    ClassName='B', !.

class([Note|_], ClassName):-
    ';'(Note==67, Note==99),
    ClassName='C', !.

class([Note|_], ClassName):-
    ';'(Note==68, Note==100),
    ClassName='D', !.

class([Note|_], ClassName):-
    ';'(Note==69, Note==101),
    ClassName='E', !.

class([Note|_], ClassName):-
    ';'(Note==70, Note==102),
    ClassName='F', !.

class([Note|_], ClassName):-
    ';'(Note==71, Note==103),
    ClassName='G', !.

/* This version accepts either a class number, or an upper or lower case 
   class letter.  The letters are exploded into numbers, and then class 
   can fill in the ClassName variable, which is usually left blank. */

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
   ';'(Note==65, ';'(ClassNumber == 65, ClassNumber==97)),
    ClassName= 'A', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
   ';'(Note==66, ';'(ClassNumber == 66, ClassNumber==98)), 
    ClassName= 'B', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
    ';'(Note==67, ';'(ClassNumber == 67, ClassNumber==99)), 
     ClassName= 'C', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
    ';'(Note==68, ';'(ClassNumber == 68,  ClassNumber==100)), 
    ClassName= 'D', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
    ';'(Note==69, ';'(ClassNumber == 69, ClassNumber==101)), 
    ClassName= 'E', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
    ';'(Note==70, ';'(ClassNumber == 70, ClassNumber==102)), 
    ClassName= 'F', !.

class(Note, ClassName):-
    name(Note, Explode),
    classCheck(Explode, ClassNumber),
    ';'(Note==71,';'(ClassNumber == 71, ClassNumber==103)), 
    ClassName= 'G', !.

classCheck([Class|_], ClassNum):- Class = ClassNum.
