/* Katy Perdue
   Created on or before June 1, 2003 */


:-ensure_loaded(scales).
:-ensure_loaded(chords).

/*  This file contains all the possible modifications to change a 
    major scale into one of the given scales.  These funtors all return 
    the modified scale in the second argument.  Other versions of most 
    of these, which simply write the modified scale, exist in the 
    file old.pl. */

aug([Root, Second, Third,_, Fifth, Sixth, Seventh],
      [Root,SharpSecond, Third, Fifth, FlatSixth,Seventh]):-
    flat(Sixth, FlatSixth),
    sharp(Second, SharpSecond).

pent([Root, Second, Third, _, Fifth, Sixth, _],
     [Root, Second, Third, Fifth, Sixth]).

bebopMaj([Root, Second, Third, Fourth, Fifth, Sixth, Seventh], 
	 [Root, Second, Third, Fourth, Fifth, SharpFifth, Sixth, Seventh]):-
    sharp(Fifth, SharpFifth).

lyd([Root, Second, Third, Fourth, Fifth, Sixth, Seventh], 
    [Root, Second, Third, SharpFourth, Fifth, Sixth, Seventh]):-
    sharp(Fourth, SharpFourth).

lydDom([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, Third, SharpFourth, Fifth, Sixth, FlatSeventh]):-
    sharp(Fourth, SharpFourth),
    flat(Seventh, FlatSeventh).

lydAug([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, Third, SharpFourth, SharpFifth, Sixth, Seventh]):-
    sharp(Fourth, SharpFourth),
    sharp(Fifth, SharpFifth).

harmMaj([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
	[Root, Second, Third, Fourth, Fifth, FlatSixth, Seventh]):-
    flat(Sixth, FlatSixth).

harmMin([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
        [Root, Second, FlatThird, Fourth, Fifth, FlatSixth, Seventh]):-
    flat(Sixth, FlatSixth),
    flat(Third, FlatThird).

blues([Root, _, Third, Fourth, Fifth, _, Seventh],
      [Root, FlatThird, Fourth, SharpFourth,  Fifth, FlatSeventh]):-
    flat(Third, FlatThird),
    sharp(Fourth, SharpFourth),
    flat(Seventh, FlatSeventh).

dimWholeTone([Root, Second, Third, Fourth, Fifth, _, Seventh],
    [Root, FlatSecond, SharpSecond,Third, SharpFourth, SharpFifth, FlatSeventh]):-
    flat(Second, FlatSecond),
    sharp(Second, SharpSecond),
    sharp(Fifth, SharpFifth),
    sharp(Fourth, SharpFourth),
    flat(Seventh, FlatSeventh).

dimH([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, FlatSecond, SharpSecond,Third, SharpFourth, Fifth, Sixth, FlatSeventh]):-
    flat(Second, FlatSecond),
    sharp(Second, SharpSecond),
    sharp(Fourth, SharpFourth),
    flat(Seventh, FlatSeventh).

dimW([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, FlatThird, Fourth, SharpFourth, SharpFifth, Sixth, Seventh]):-
    flat(Third, FlatThird),
    sharp(Fourth, SharpFourth),
    sharp(Fifth, SharpFifth).

dim8([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, FlatThird, Fourth, FlatFifth, FlatSixth, Sixth, Seventh]):-
    flat(Third, FlatThird),
    flat(Fifth, FlatFifth),
    flat(Sixth, FlatSixth).

wholeTone([Root, Second, Third, Fourth, Fifth, _, Seventh],
    [Root, Second, Third, SharpFourth, SharpFifth, FlatSeventh]):-
    flat(Seventh, FlatSeventh),
    sharp(Fourth, SharpFourth),
    sharp(Fifth, SharpFifth).

harmMin6Mode([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
         [Root, SharpSecond,Third,SharpFourth,Fifth,Sixth,Seventh]):-
    sharp(Second, SharpSecond),
    sharp(Fourth, SharpFourth).

bebopLoc([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
	 [Root, FlatSecond, FlatThird,Fourth,FlatFifth,Fifth,FlatSixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Second, FlatSecond),
    flat(Fifth, FlatFifth),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

hindu([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, Third,Fourth,Fifth,FlatSixth,FlatSeventh]):-
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

phyr([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, FlatSecond, FlatThird,Fourth,Fifth,FlatSixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Second, FlatSecond),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

pure([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, FlatThird,Fourth,Fifth,FlatSixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

loc([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, FlatSecond, FlatThird,Fourth,FlatFifth,FlatSixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Fifth, FlatFifth),
    flat(Second, FlatSecond),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

locSharp2([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
	  [Root, Second, FlatThird,Fourth,FlatFifth,FlatSixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Fifth, FlatFifth),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

dor([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, Second, FlatThird, Fourth, Fifth, Sixth, FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Seventh, FlatSeventh).

bebopMin([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
	 [Root, Second, FlatThird, Third,Fourth, Fifth,Sixth,FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Seventh, FlatSeventh).

bebopMin2([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
         [Root, Second, FlatThird,Fourth, Fifth, SharpFifth,Sixth,Seventh]):-
    flat(Third, FlatThird),
    sharp(Fifth, SharpFifth).

melMin([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
       [Root, Second, FlatThird, Fourth, Fifth, Sixth, Seventh]):-
    flat(Third, FlatThird).

pentMin([Root, _, Third, Fourth, Fifth, _, Seventh],
	[Root, FlatThird, Fourth, Fifth, FlatSeventh]):-
    flat(Third, FlatThird),
    flat(Seventh, FlatSeventh).

susPent([Root, Second, _, Fourth, Fifth, _, Seventh],
        [FlatSeventh, Root, Second, Fourth, Fifth]):-
    flat(Seventh, FlatSeventh).

bebopDom([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
         [Root, Second, Third,Fourth, Fifth,Sixth,FlatSeventh, Seventh]):-
    flat(Seventh, FlatSeventh).

dom([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
         [Root, Second, Third,Fourth, Fifth,Sixth,FlatSeventh]):-
    flat(Seventh, FlatSeventh).

spanish([Root, Second, Third, Fourth, Fifth, Sixth, Seventh],
    [Root, FlatSecond, Third, Fourth, Fifth,FlatSixth, FlatSeventh]):-
    flat(Second, FlatSecond),
    flat(Sixth, FlatSixth),
    flat(Seventh, FlatSeventh).

maj(X,X).

