/* Katy Perdue
   Created on or before May 28, 2003 */

:- ensure_loaded(scales).
:-ensure_loaded(equals).
:-ensure_loaded(class).

/*This section determines the roman numeral designation of a chord,
given the tonic key.   First, the class of the two chords is 
determined, by the class functor located in a a different file.  
Then, the relationship between the two classes is found, by 
comparing the numeric representation of the classes. */

/* roman(Chord, Tonic):- roman(Chord, Tonic, _).*/

roman(Tonic, Chord , RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,1)); (ChordNum==65, TonicNum==71)), 
    RomNum='II'.


roman(Tonic, Chord, RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,4)); (ChordNum is -(TonicNum, 3))),
    RomNum='V'.


roman(Tonic, Chord, RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,3)); (ChordNum is -(TonicNum, 4))),
    RomNum='IV'.

roman(Tonic, Chord, RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,2)); (ChordNum is -(TonicNum, 5))),
    RomNum='III'.

roman(Tonic, Chord, RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,5)); (ChordNum is -(TonicNum, 2))),
    RomNum='VI'.

roman(Tonic, Chord, RomNum):-
    class(Chord, ChordClass),
    class(Tonic, TonicClass),
    name(TonicClass, [TonicNum]),
    name(ChordClass, [ChordNum]),
    ((ChordNum is +(TonicNum,6)); (ChordNum is -(TonicNum, 1))),
    RomNum='VII'.





